//Un noeud quelconque
package
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.events.MouseEvent;//Interaction utilisateur//souris
	import flash.filters.BitmapFilter;
	import flash.filters.GlowFilter;

	public class Noeud extends Sprite
	{
		private var Final_Glow:int;//La valeur de rayonnement dsire
		private var Current_Glow:Number;//Le rayonnement actuel du noeud

		private var Layer:Niveau;//Le conteneur
		private var Liens:Array;

		private var LastDragEvent:uint;

		private const RAYON:int=20;

		public function Noeud(Layer:Niveau,x:Number,y:Number,NbNoeuds:int=1)
		{//Instancie un nouveau noeud

			this.Layer = Layer;
			this.Liens=new Array();

			this.x=x;
			this.y=y;

			this.graphics.beginFill(0xEEEEEE);
			this.graphics.lineStyle(1,0x000000);
			this.graphics.drawCircle(0, 0, Math.max(7,RAYON-NbNoeuds));//Plus il y a de noeuds, plus le dessin est petit. Mais on impose une taille minimum !

			Layer.addChild(this);
			this.Final_Glow=this.Current_Glow=0;
		}

		public function AjouterLien(Lien:Arc):void
		{
			Liens.push(Lien);
		}

		public function set Passif(value:Boolean):void
		{
			if(value==true)
			{
				//Empeche toute action sur le noeud
				this.removeEventListener(MouseEvent.MOUSE_OVER,SourisIN);
				this.removeEventListener(MouseEvent.MOUSE_OUT,SourisOUT);
				this.removeEventListener(MouseEvent.MOUSE_DOWN,SourisDown);
				SourisOUT(); //Simuler une sortie de souris, pour supprimer le drag et les filtres.
			}
			else
			{//Remettre les venements souris.
				this.addEventListener(MouseEvent.MOUSE_OVER,SourisIN);
				this.addEventListener(MouseEvent.MOUSE_OUT,SourisOUT);
				this.addEventListener(MouseEvent.MOUSE_DOWN,SourisDown);
			}
		}

		//Fonctions prives
		private function Dragger(e:Event=null):void
		{
			for each(var Lien:Arc in Liens)
				Lien.Refresh();
		}

		private function SourisDown(e:Event):void
		{//Dragger : supprimer les venements obsolets, ajouter les nouveaux.
			this.addEventListener(MouseEvent.MOUSE_MOVE,Dragger);
			this.removeEventListener(MouseEvent.MOUSE_DOWN,SourisDown);
			this.addEventListener(MouseEvent.MOUSE_UP,SourisUp);
// 			stage.frameRate=50;//Acclerer le nombre de FPS (remise  la normale dans SourisUp)
			this.startDrag();
		}
		private function SourisUp(e:Event):void
		{
			this.addEventListener(MouseEvent.MOUSE_DOWN,SourisDown);
			this.removeEventListener(MouseEvent.MOUSE_UP,SourisUp);
			this.removeEventListener(MouseEvent.MOUSE_MOVE,Dragger);
			this.stopDrag();
// 			stage.frameRate=25;
			this.Dragger(); //En cas de drag rapide, il peut y avoir dcalage : avec cette instruction, on met  jour de faon sre.
		}

		private function AddFocus(Level:int):void
		{//Ajoute un flou  la forme.
			this.Final_Glow=Level;
			this.addEventListener(Event.ENTER_FRAME,ChangeFiltre);
		}

		private function SourisIN(e:MouseEvent):void
		{//Ajoute un filtre indiquant que la forme est hovere
			AddFocus(5);
		}
		private function SourisOUT(e:MouseEvent=null):void
		{//Ajoute un filtre indiquant que la forme n'est plus hovere
			AddFocus(0);
		}

		private function ChangeFiltre(e:Event=null):void
		{//gestion des filtres dans le temps

			//Filtre HOVER
			if(Current_Glow<Final_Glow)
				Current_Glow=Math.min(Final_Glow,Current_Glow+0.2);
			else
				Current_Glow=Math.max(Final_Glow,Current_Glow-0.1);

			var ListeFiltres:Array = new Array();
			var ListeFiltreDescendants:Array=new Array();
			if(Current_Glow!=0)
			{
				ListeFiltres.push(new GlowFilter(0x00FF00, 0.8,16,16,Current_Glow,1,false,false));
				ListeFiltreDescendants.push(new GlowFilter(0x0000FF, 0.8,16,16,Current_Glow/2,1,false,false));
			}

			this.filters=ListeFiltres;

			for each(var Lien:Arc in Liens)
			{
				if(Lien.Extremites[0]==this)
					Lien.Extremites[1].filters = ListeFiltreDescendants;
				else
					Lien.Extremites[0].filters = ListeFiltreDescendants;
			}

			//Enlever l'venement afin de dcharger la mmoire.
			if(Current_Glow==Final_Glow)
				this.removeEventListener(Event.ENTER_FRAME,ChangeFiltre);
		}
	}
}